$.support.cors = true;

String.prototype.format = function () {
	var args = arguments;
	return this.replace(/{(\d+)}/g, function (match, number) {
		return typeof args[number] != 'undefined'
		  ? args[number]
		  : match
		;
	});
};

function changeIpAddress()
{
	ipString = prompt("Please enter the console IP Address:", "");
	localStorage.setItem("ip",ipString);
}

function ipAddress()
	{
		var ipString = localStorage.getItem("ip");
		if(ipString == null)
		{
			changeIpAddress();
		}		
		return ipString;
		
	};

function runAcw(script,success)
{
	var parts = script.split("(");
	var functionName = parts[0].replace(/\./g,"/");	
	var arguments = parts[1].replace(/,/g,"&").replace(")","").replace(/'/g,"");
	
	var url = "http://{0}:4430/titan/script/{1}".format(ipAddress(),functionName + "?"+ arguments);
	$.get(url, function (data, status) {
		success();
	});
};

function getAcw(script, success, fail)
{
	script = script.replace(/\./g,"/").replace(/,/g,"&").replace("(","?").replace(")","");
	var url = "http://{0}:4430/titan/get/{1}".format(ipAddress(),script);
	$.getJSON(url, success)
	.fail(function (jqXHr, textStatus, errorThrown) {
		alert(jqXHr.statusText);
	});
}

function deviceInfo(success)
{
	getAcw("Titan.DeviceInfo",success);
}

function killPlayback(groupId, titanId) 
{
	runAcw("Playbacks.KillAllPlaybacks()");
};

function killAllPlaybacks(){
	runAcw("Playbacks.KillAllPlaybacks()");
};

function firePlayback(userNumber,level){
	runAcw("Playbacks.FirePlaybackAtLevel(userNumber={0},level={1},bool=false)".format(userNumber,level));
};

function refirePlayback(userNumber,level){
	runAcw("Playbacks.FirePlaybackAtLevel(userNumber={0},level={1},bool=true)".format(userNumber,level));
};

function togglePlayback(userNumber) {
	runAcw("Playbacks.ToggleLatchPlayback(userNumber={0})".format(userNumber));
};

function killPlayback(userNumber){
	runAcw("Playbacks.KillPlayback(userNumber={0})".format(userNumber));
}

function setNextCue(userNumber,cueNumber){
	runAcw("CueLists.SetNextCue(userNumber={0},float={1})".format(userNumber,cueNumber));
};

function go(userNumber){
	runAcw("CueLists.Play(userNumber={0})".format(userNumber));
};

function pause(userNumber){
	runAcw("CueLists.Pause(userNumber={0})".format(userNumber));
};

function goBack(userNumber){
	runAcw("CueLists.GoBack(userNumber={0})".format(userNumber));
};

function snapNext(userNumber){
	runAcw("CueLists.CutNextCueToLive(userNumber={0})".format(userNumber));
};

function snapBack(userNumber){
	runAcw("CueLists.SnapBack(userNumber={0})".format(userNumber));
};

function fireMacro(userNumber){
	runAcw("UserMacros.RecallMacro(userNumber={0})".format(userNumber));
};

function lampOn()
{
	runAcw("Fixtures.Macros.FireMacro('Lamp On')");
}

function lampOff()
{
	runAcw("Fixtures.Macros.FireMacro('Lamp Off')");
}